=== debian/changelog ===
hipcub (5.3.3-4) unstable; urgency=medium

  * Migrate to unstable.
  * d/copyright: add debian directory

 -- Cordell Bloor <cgmb@slerp.xyz>  Wed, 12 Jul 2023 02:43:49 -0600

hipcub (5.3.3-4~exp1) experimental; urgency=medium

  * Add libhipcub-tests package for autopkgtests.
  * d/control: fix maintainer name
  * d/rules: explicitly disable lto

 -- Cordell Bloor <cgmb@slerp.xyz>  Fri, 07 Jul 2023 13:15:34 -0600

hipcub (5.3.3-3) unstable; urgency=medium

  * d/rules: enable hardening flags in tests
  * d/control: add dependency on librocprim-dev

 -- Cordell Bloor <cgmb@slerp.xyz>  Tue, 16 May 2023 00:09:04 -0600

hipcub (5.3.3-2) unstable; urgency=medium

  * Team upload.
  * Source-only upload.

 -- Christian Kastner <ckk@debian.org>  Thu, 02 Mar 2023 19:08:56 +0100

hipcub (5.3.3-1) unstable; urgency=medium

  [ Cordell Bloor ]
  * Initial release. (Closes: #1023090)

 -- Cordell Bloor <cgmb@slerp.xyz>  Thu, 05 Jan 2023 01:28:48 -0700
