=== debian/control ===
Source: hipcub
Section: devel
Homepage: https://github.com/rocmsoftwareplatform/hipcub
Priority: optional
Standards-Version: 4.6.2
Vcs-Git: https://salsa.debian.org/rocm-team/hipcub.git
Vcs-Browser: https://salsa.debian.org/rocm-team/hipcub
Maintainer: Debian ROCm Team <debian-ai@lists.debian.org>
Uploaders: Cordell Bloor <cgmb@slerp.xyz>,
Build-Depends: debhelper-compat (= 13),
               cmake,
               hipcc,
               libamd-comgr-dev,
               libhsa-runtime-dev,
               patchelf,
               rocminfo,
               rocm-cmake,
               librocprim-dev,
               libgtest-dev
Rules-Requires-Root: no

Package: libhipcub-dev
Section: libdevel
Architecture: all
Depends: ${misc:Depends},
         librocprim-dev,
Description: portable interface for GPU parallel primitives - headers
 hipCUB is a header-only wrapper library that provides a common interface to
 rocPRIM and CUB. The hipCUB library is designed to help applications using CUB
 to port their code to the ROCm platform.
 .
 This package provides AMD ROCm hipCUB development headers.

Package: libhipcub-tests
Section: libdevel
Architecture: amd64 arm64 ppc64el
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: portable interface for GPU parallel primitives - tests
 hipCUB is a header-only wrapper library that provides a common interface to
 rocPRIM and CUB. The hipCUB library is designed to help applications using CUB
 to port their code to the ROCm platform.
 .
 This package provides the AMD ROCm hipCUB test binaries. These binaries are
 only used to check whether hipCUB works correctly on a given GPU, so
 generally speaking, users probably don't need this package.
