=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%hipcub-$1.tar.gz%" \
    https://github.com/rocmsoftwareplatform/hipcub/tags \
    (?:.*?/)?rocm-v?(\d[\d.]*)\.tar\.gz debian
